
(* ベクトルと行列の計算, 表示 *)

(* 行ベクトル *)

(* 組 tuple *)
let x = (1.,2.,0.)
let y = (1., -1., 2.)

let ( +& ) (x1,x2,x3) (y1,y2,y3) =
  (x1+.y1, x2+.y2, x3+.y3)
    
(* 配列での表現 *)
(* 行ベクトル *)
let vl = [| 1.; 2.; 3. |]
let wl = [| 0.; -.1.; 2. |]

let add_vl v w dim =
  Array.init dim (fun n -> v.(n) +. w.(n))
let ( +$ ) v w = add_vl v w 3
let print_vl v =
  Printf.printf "row vector : \n";
  Array.iter (Printf.printf "%f ") v;
  Printf.printf "\n"

(* 列ベクトル *)
let vc = [| [|1.|]; [|2.|]; [|3.|] |]
let wc = [| [|0.|]; [|-.1.|]; [|2.|] |]
    
let add_vc v w dim =
  Array.init dim (fun n -> [| v.(n).(0) +. w.(n).(0) |] )

let ( +! ) v w = add_vc v w 3
let print_vc v =
  Printf.printf "column vector : \n";
  Array.iter (fun r -> Printf.printf "%f\n" r.(0)) v


let () =
  print_vl (vl +$ wl);
  print_vc (vc +! wc)
