Require Import Arith.
Require Import List.

Inductive fchar := { num : nat; mean : nat }.


Fixpoint fermi_estimate (fls : list fchar) : nat :=
  match fls with
    | nil => 0
    | f :: fs => num f * mean f + fermi_estimate fs
  end.


Lemma plus_zero : forall (n : nat), n + 0 = n.
Proof.
  intros.
  induction n.
  reflexivity.
  simpl.
  rewrite IHn.
  reflexivity.
Qed.
  
Lemma fchar_sum : forall (n1 m1 n2 m2 : nat), fermi_estimate ((Build_fchar n1 m1) :: (Build_fchar n2 m2) :: nil) = n1*m1 + n2*m2.
Proof.
  intros.
  simpl.
  rewrite plus_zero.
  reflexivity.
Qed.