
(* Euler 法による 予測子 - 修正子法 *)
let pece_euler doti (q0, i0) h n =
  let i1 = q0 +. h *. doti q0 i0 ((float n)*.h) in
  let q1 = q0 +. h *. i0 in
  let i2 = i0 +. 0.5 *. h *. ((doti q1 i1 ((float (n+1))*.h)) +. (doti q0 i0 ((float (n+1))*.h))) in
  let q2 = q0 +. 0.5 *. h *. (i1 +. i0) in
  (q2, i2)


let pi = 4. *. atan 1.
let () =
  let phi = 0. in
  let doti q v t = -. v -. 100. *. q +. 14.1 *. sin (120.*.pi*.t +. phi) in
  let rec dump_solution doti (q0, i0) h ns n =
    let (q1, i1) = pece_euler doti (q0, i0) h n in
    print_endline (string_of_float i1); 
    if n+1 >= ns then ()
    else dump_solution doti (q1, i1) h ns (n+1)
  in

  dump_solution doti (0.,0.) 0.0005 5000 0 
